#include <gtk/gtk.h>
#include <libcell.h>
#include <stdio.h>

GtkWidget *window, *connect_button, *connect_label;
GtkWidget *plc_address, *connect_box, *vbox;
GtkWidget *statusbar, *taglist, *tag_window, *tagbox;
GtkWidget *value, *plc_label, *plc_address_box, *tagtext;
GtkWidget *progbox, *proglist, *proglabel, *progvbox, *topline, *progboxtext;
GtkWidget *data_window, *data_widget, *rightwin, *midline;
GtkAdjustment *data_win_adj;

gchar *titles[] = { "Tag Name            ","Type      ","A1 ","A2 ","A3 ","Topbase   ","Link ID    ","DataSize"};
gchar *progtitle[] = { "Tag Scope"};
gchar *progline[] = { NULL, NULL} ;
gchar junk[128];

_comm_header *comm;
_services *services;
_rack *rack;
_path *path;
_backplane_data *backplane;
_tag_data *detailtags, *progtags[64];
_prog_list *progs;
_tag_data *program_tags[64];

#define UPDATE_WIN while (gtk_events_pending()) gtk_main_iteration()
int prognum,tagnum;

guint statusbar_context;
int debug = DEBUG_NIL;

static void set_status_message (GtkWidget *statusbar, guint context, const gchar *text)
{
gtk_statusbar_pop(GTK_STATUSBAR(statusbar), context);
gtk_statusbar_push(GTK_STATUSBAR(statusbar), context, text);
gtk_widget_show(statusbar);
UPDATE_WIN;
return;
}

static void destroy (GtkWidget *widget, gpointer data)
{
gtk_main_quit();
}


static gint delete_event_cb (GtkWidget* w, GdkEventAny* e, gpointer data)
{
return FALSE;
}

/*
void set_win_icon (GtkWidget *win, gpointer data)
{
static GdkPixmap *icon_pmap = NULL;
static GdkBitmap *icon_mask = NULL;
GtkStyle *style;

style = gtk_widget_get_style (win);

if (icon_pmap == NULL)
	icon_pmap = gdk_pixmap_create_from_xpm_d (win->window, &icon_mask, &style->bg[GTK_STATE_NORMAL], gcl_xpm);
gdk_window_set_icon (win->window, NULL, icon_pmap, icon_mask);
}
*/


static gint display_tags (GtkWidget* w, gpointer *data)
{
int x;
tagnum = -1;
prognum = GPOINTER_TO_INT(data) - 1;

gtk_clist_clear(GTK_CLIST(taglist));

if (prognum == -1)
	{
	for (x = 0; x < detailtags->count; x++)
		{
		gchar *row[] = { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL };
		gchar name[48], type[10], a1[10], a2[10], a3[10], tb[10], li[10], sz[10];
		aliascheck (detailtags->tag[x], NULL, detailtags, debug);
		sprintf (name,"%s",detailtags->tag[x]->name);
		sprintf (type,"%04X",detailtags->tag[x]->type);
		sprintf (a1,"%ld",detailtags->tag[x]->arraysize1);
		sprintf (a2,"%ld",detailtags->tag[x]->arraysize2);
		sprintf (a3,"%ld",detailtags->tag[x]->arraysize3);
		sprintf (tb,"%08lX",detailtags->tag[x]->topbase);
		sprintf (li,"%08lX",detailtags->tag[x]->linkid);
		sprintf (sz,"%d",detailtags->tag[x]->size);
		row[0] = name;
		row[1] = type;
		row[2] = a1;
		row[3] = a2;
		row[4] = a3;
		row[5] = tb;
		row[6] = li;
		row[7] = sz;

		gtk_clist_append (GTK_CLIST(taglist),row);
		gtk_clist_set_row_data (GTK_CLIST(taglist),x,x);
		}
	}

if (prognum != -1)
	{
	for (x=0;x<program_tags[prognum]->count; x++)
		{
		gchar *row[] = { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL };
		gchar name[48], type[10], a1[10], a2[10], a3[10], tb[10], li[10], sz[10];
		//aliascheck (program_tags[prognum]->tag[x], NULL, detailtags, debug);
		program_tags[prognum]->tag[x]->dirty = x;
		sprintf (name,"%s",program_tags[prognum]->tag[x]->name);
		sprintf (type,"%04X",program_tags[prognum]->tag[x]->type);
		sprintf (a1,"%ld",program_tags[prognum]->tag[x]->arraysize1);
		sprintf (a2,"%ld",program_tags[prognum]->tag[x]->arraysize2);
		sprintf (a3,"%ld",program_tags[prognum]->tag[x]->arraysize3);
		sprintf (tb,"%08lX",program_tags[prognum]->tag[x]->topbase);
		sprintf (li,"%08lX",program_tags[prognum]->tag[x]->linkid);
		sprintf (sz,"%d",program_tags[prognum]->tag[x]->size);
		row[0] = name;
		row[1] = type;
		row[2] = a1;
		row[3] = a2;
		row[4] = a3;
		row[5] = tb;
		row[6] = li;
		row[7] = sz;

		gtk_clist_append (GTK_CLIST(taglist),row);
		gtk_clist_set_row_data (GTK_CLIST(taglist), x,x);

		}
	}
			
gtk_clist_columns_autosize(GTK_CLIST(taglist));
gtk_clist_set_sort_column(GTK_CLIST(taglist), 0);
gtk_clist_sort (GTK_CLIST(taglist));
return TRUE;

}

static gint setup_read_tag (GtkWidget* w, gpointer *data)
{
int x;
x = GPOINTER_TO_INT(data);
tagnum = GPOINTER_TO_INT(gtk_clist_get_row_data(GTK_CLIST(taglist), x));
gtk_adjustment_set_value(GTK_TEXT(data_widget)->vadj,0.0);
data_win_adj = gtk_scrolled_window_get_vadjustment (GTK_SCROLLED_WINDOW(data_window));
data_win_adj->value = 0.0;
gtk_scrolled_window_set_vadjustment (GTK_SCROLLED_WINDOW(data_window), data_win_adj);

return TRUE;
}


static gint read_tag_value (GtkWidget* w, gpointer *data)
{

int x;
char msg[4096];
_tag_detail *tag;

gtk_text_freeze(GTK_TEXT(data_widget));
gtk_text_set_point(GTK_TEXT(data_widget),0);
data_win_adj = gtk_scrolled_window_get_vadjustment (GTK_SCROLLED_WINDOW(data_window));
gtk_text_forward_delete(GTK_TEXT(data_widget),gtk_text_get_length(GTK_TEXT(data_widget)));

if (tagnum == -1)
	{
	gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "Please click a tag to read it's value.\n",-1);
	gtk_text_thaw (GTK_TEXT(data_widget));
	return TRUE;
	}

memset (&msg,0,4096);

if (prognum == -1)
	tag = detailtags->tag[tagnum];
if (prognum != -1)
	tag = program_tags[prognum]->tag[tagnum];
if (tag->type & 0x1000)
	gtk_text_insert (GTK_TEXT(data_widget),NULL, NULL, NULL, "Can not read system data types.",-1);
	
if (!(tag->type & 0x1000))
	{
	int z,result;
	
	result = read_object_value (comm, path, tag, debug);
	if (tag->arraysize1 == 0)
		tag->arraysize1 = 1;
	for(z=0;z<tag->arraysize1;z++)
		{
		union {
			_counter count;
			_timer timer;
			_fault fault;
			_alarm alarm;
			char c;
			short s;
			int i;
			long l;
			long long ll;
			float f;
			double d;
			unsigned char uc;
			unsigned short us;
			unsigned int ui;
			unsigned long ul;
			unsigned long long ull;
			_wall_clock wc;
			_state_data state;
			_hmi_heartbeat hmi;
			} types;

		if (result == 0)
			{
			memcpy (&types, (void *)(tag->data) + (z*tag->size), tag->size);
			memset (&msg,0,4096);
			sprintf (msg,"%s[%d]: ",tag->name,z); 	
			gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL ,msg, strlen(msg));

			switch (tag->type & 255)
				{
				case 0x82:
					memset (&msg,0,4096);
					gtk_text_insert (GTK_TEXT(data_widget),NULL, NULL, NULL, "\nCounter: \n\nFlags :",7);
					if (types.count.ctl & COUNTER_CU)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "CU ",3);
					if (types.count.ctl & COUNTER_CD)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "CD ",3);
					if (types.count.ctl & COUNTER_DN)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "DN ",3);
					if (types.count.ctl & COUNTER_OV)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "OV ",3);
					if (types.count.ctl & COUNTER_UN)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "UN ",3);
					sprintf (msg,"\n");
					gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
	
					memset (&msg,0,4096);
					sprintf (msg, "Preset: %lu\n",types.count.preset);
					gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
				
					memset (&msg,0,4096);
					sprintf (msg, "Accumulator: %lu\n",types.count.accumulator);
					gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
					break;
			
				case 0x83:
					memset (&msg,0,4096);
					sprintf (msg, "\nTimer Datatype:\n\nHeartbeat: %ld\n",(long)(types.timer.heartbeat[2]*65536) + (types.timer.heartbeat[1] * 256) + types.timer.heartbeat[0]);
					gtk_text_insert (GTK_TEXT(data_widget),NULL, NULL, NULL, msg, strlen(msg));
					
					gtk_text_insert (GTK_TEXT(data_widget),NULL, NULL, NULL, "Flags :",7);
					if (types.timer.ctl & TIMER_EN)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "EN ",3);
					if (types.timer.ctl & TIMER_TT)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "TT ",3);
					if (types.timer.ctl & TIMER_DN)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "DN ",3);
					if (types.timer.ctl & TIMER_FS)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "FS ",3);
					if (types.timer.ctl & TIMER_LS)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "LS ",3);
					if (types.timer.ctl & TIMER_OV)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "OV ",3);
					if (types.timer.ctl & TIMER_ER)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "ER ",3);
					sprintf (msg,"\n");
					gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
				
					memset (&msg,0,4096);
					sprintf (msg, "Preset: %lu\n",types.timer.preset);
					gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
				
					memset (&msg,0,4096);
					sprintf (msg, "Accumulator: %lu\n",types.timer.accumulator);
					gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
					break;

				case 0x8b:
					memset (&msg,0,4096);
					sprintf (msg,"\nAlarm datatype:\n\n");
					gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
					
					memset(&msg,0,4096);
					gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, "Enable IN: ",-1);
					if (types.alarm.ctl & ALARM_ENABLE_IN)
						gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, "TRUE", 4);
					if (!(types.alarm.ctl & ALARM_ENABLE_IN))
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "FALSE", 5);
					sprintf (msg,"\nInput Value: %f\nHigh High Limit: %f\nHigh Limit: %f\n", \
						types.alarm.input, types.alarm.hhlimit, types.alarm.hlimit);
					gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
				
					memset(&msg,0,4096);
					sprintf (msg,"Low Limit: %f\nLow Low Limit: %f\nDead Band: %f\nROC Positive Limit: %f\nROC Negative Limit: %f\nROC Period: %f\nROC: %f\n", \
						types.alarm.llimit, types.alarm.lllimit, types.alarm.deadband, types.alarm.roc_pos_limit, types.alarm.roc_neg_limit, types.alarm.roc_period,types.alarm.roc);
				
					gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
	

					memset(&msg,0,4096);
					gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "Alarms: ", 8);
					if (types.alarm.alarms & ALARM_ENABLE_OUT)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "ENB ", 4);
					if (types.alarm.alarms & ALARM_HH_ALARM)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "HH ",3);
					if (types.alarm.alarms & ALARM_H_ALARM)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "H ", 2);
					if (types.alarm.alarms & ALARM_L_ALARM)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "L ", 2);
					if (types.alarm.alarms & ALARM_LL_ALARM)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "LL ", 3);
					if (types.alarm.alarms & ALARM_ROC_POS_ALARM)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "ROC+ ", 5);
					if (types.alarm.alarms & ALARM_ROC_NEG_ALARM)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "ROC- ", 5);
					sprintf (msg,"\nStatus: ");
					gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
				
				
					if (types.alarm.status & ALARM_INSTRUCT_FAULT)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "INS_FLT ", 8);
					if (types.alarm.status & ALARM_DEADBAND_INV)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "DB_INV ", 7);
					if (types.alarm.status & ALARM_ROC_POS_INV)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "ROC+INV ", 8);
					if (types.alarm.status & ALARM_ROC_NEG_INV)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "ROC-INV ", 8);
					if (types.alarm.status & ALARM_ROC_PERIOD_INV)
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "ROC.INV ", 8);
					memset (&msg,0,4096);
					sprintf (msg,"\n");
					gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
				
					break;
				
				
				case 0xac:
					memset (&msg,0,4096);
					sprintf (msg,"\nHMI Heartbeat\n\n");
					gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
				
					memset (&msg,0,4096);
					sprintf (msg, "HMI Heartbeat: %d [%04X]\nHMI Last: %d [0x%04X]\nAB Heartbeat: %d [0x%04X]\n", \
						types.hmi.hmi_hb, types.hmi.hmi_hb, types.hmi.hmi_last, types.hmi.hmi_last, \
						types.hmi.ab_hb, types.hmi.ab_hb);
					gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
					break;
				
				case 0xbe:
					memset (&msg,0,4096);
					sprintf (msg,"\nWall Clock\n\n");
					gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
				
					memset (&msg,0,4096);
					sprintf (msg,"CTOffset[0]: %ld [0x%08lX]\nCTOffset[1]: %ld [0x%08lX]\n", \
						types.wc.CTOffset[0],types.wc.CTOffset[0], types.wc.CTOffset[1], types.wc.CTOffset[1]);
					gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
				
					memset (&msg,0,4096);
					sprintf (msg,"CurrentValue[0]: %ld [0x%08lX]\nCurrentValue[1]: %ld [0x%08lX]\n\n", \
						types.wc.CurrentValue[0], types.wc.CurrentValue[0], types.wc.CurrentValue[1], types.wc.CurrentValue[1]);
					gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
					
					memset (&msg,0,4096);
					sprintf (msg,"TimeStamp: %04ld/%02ld/%02ld %2ld:%02ld:%02ld.%ld\n", types.wc.year, types.wc.month, types.wc.date, \
						types.wc.hour, types.wc.minute, types.wc.seconds, types.wc.micro);
					gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
					break;
				
				case 0xb5:
					memset (&msg,0,4096);
					sprintf (msg,"\nFault History\n\n");
					gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
				
					memset (&msg,0,4096);
					sprintf (msg,"Time Low: %ld\nTime High: %ld\nType: %d (0x%04X)\nCode: %d (0x%04X)\n", \
						types.fault.timelow, types.fault.timehigh, types.fault.type, types.fault.type, \
						types.fault.code, types.fault.code);
					gtk_text_insert (GTK_TEXT(data_widget),NULL, NULL, NULL, msg, strlen(msg));
					for (x=0;x<8;x++)
						{
						memset (&msg,0,4096);
						sprintf (msg,"Info[%d] - %08lX\n",x,types.fault.info[x]);
						gtk_text_insert(GTK_TEXT(data_widget),NULL, NULL, NULL, msg, strlen(msg));
						}
					break;

				case 0xc1:
					x = pow(2,(tag->type>>8));
					memset (&msg,0,4096);
					if (tag->data[0] & x)
						sprintf (msg,"True  (%d & %d)\n",tag->data[0],x);
					if (!(tag->data[0] & x))
						sprintf (msg,"False  (%d & %d)\n",tag->data[0],x);
					gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
					break;

				case 0xc2:
					if (((tag->type >> 8) & 0x0f) == 0)
						{
						memset (&msg,0,4096);
						sprintf (msg," %d (0x%02X)\n",types.c, types.c);
						gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
						}
					else 
						{
						
						memset (&msg,0,4096);
						sprintf (msg,"\nState Data\n\n");
						gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
						
						memset (&msg,0,4096);
						sprintf (msg,"Current State: %d [0x%04X]\nDestination State: %d [0x%04X]\n", \
							types.state.current_state, types.state.current_state, \
							types.state.destination_state, types.state.destination_state);
						gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
						
						memset (&msg,0,4096);
						if (types.state.in_transition == 0)
							sprintf (msg,"In Transition: FALSE\n");
						if (types.state.in_transition == 1)
							sprintf (msg,"In Transition: TRUE\n");
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
						
						memset (&msg,0,4096);
						sprintf (msg,"Abort Code: %d [0x%04X]\nHeartBeat: %d [%04X]\n", \
							types.state.abort_code, types.state.abort_code, types.state.heartbeat, types.state.heartbeat);
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
						
						memset (&msg,0,4096);
						sprintf (msg, "HS-DATA: %ld [0x%08lX]\nSystem Data: %ld [0x%08lX]\n", types.state.hs_data, \
							types.state.hs_data, types.state.sys_status, types.state.sys_status);
						gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
						}
					break;
					
				case 0xc3:
					memset (&msg,0,4096);
					sprintf (msg, " %d (0x%04X)\n",types.s, types.s);
					gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
					break;
				case 0xc4:
					memset (&msg,0,4096);
					sprintf (msg," %d (0x%08X)\n",types.i, types.i);
					gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
					break;
		
				case 0xc5:
					memset (&msg,0,4096);
					sprintf (msg," %ld (0x%016lX)\n",types.l, types.l);
					gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
					break;
				case 0xc6:
					memset (&msg,0,4096);
					sprintf (msg," %u (0x%02X)\n",types.uc, types.uc);
					gtk_text_insert(GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
					break;	
				case 0xca:
					memset(&msg,0,4096);
					sprintf (msg, " %f\n",types.f);
					gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
					break;
				case 0xcb:
					memset (&msg,0,4096);
					sprintf (msg, " %f\n",types.d);
					gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, msg, strlen(msg));
					break;		
	
				default:
					for (x=0;x<tag->size;x++)
						{
						memset (&msg,0,4096);
						sprintf (msg,"%02X ",tag->data[x]);
						gtk_text_insert (GTK_TEXT(data_widget),NULL, NULL, NULL,msg,strlen(msg));
						}
				}
			}
		}
	}

gtk_scrolled_window_set_vadjustment (GTK_SCROLLED_WINDOW(data_window), data_win_adj);
gtk_text_thaw(GTK_TEXT(data_widget));

return TRUE;
}


static gint connect_to_plc (GtkWidget *w, GdkEventAny* e, gpointer data)
{
int x,y,z;
gchar text[255];

tagnum = -1;
if (comm) free(comm);
if (services) free (services);
if (rack) free (rack);
if (path) free (path);
if (backplane) free (backplane);
if (detailtags) free (detailtags);
if (progs)
	for (x=0;x<progs->count;x++)
		if (program_tags[x]) free (program_tags[x]);
if (progs) free (progs);


/* CELL initializations here */
comm = malloc(sizeof(_comm_header));
if (comm == NULL)
	{
	printf ("Couldn't allocate COMM structure.\n");
	exit(-1);
	}
services = malloc(sizeof(_services));
if (services == NULL)
	{
	printf ("Couldn't allocate SERVICES structure.\n");
	free (comm);
	exit(-1);
	}

rack = malloc(sizeof(_rack));
if (rack == NULL)
	{
	printf ("Couldn't allocate RACK structure.\n");
	free (services);
	free (comm);
	exit(-1);
	}
path = malloc(sizeof(_path));
if (path == NULL)
	{
	printf ("Couldn't allocate PATH structure.\n");
	free (rack);
	free (services);
	free (comm);
	exit(-1);
	}
backplane = malloc(sizeof(_backplane_data));
if (backplane == NULL)
	{
	printf ("Couldn't allocate BACKPLANE structure.\n");
	free (path);
	free (rack);
	free (services);
	free (comm);
	exit(-1);
	}
detailtags = malloc(sizeof(_tag_data));
if (detailtags == NULL)
	{
	printf ("Could not allocate DETAILTAGS structure.\n");
	free (backplane);
	free (path);
	free (rack);
	free (services);
	free (comm);
	exit(-1);
	}
progs = malloc(sizeof(_prog_list));
if (progs == NULL)
	{
	free (detailtags);
	free (backplane);
	free (path);
	free (rack);
	free (services);
	free (comm);
	exit(-1);
	}


memset (comm, 0, sizeof(_comm_header));
memset (services, 0, sizeof(_services));
memset (rack, 0, sizeof(_rack));
memset (path, 0, sizeof (_path));
memset (backplane, 0, sizeof (_backplane_data));
memset (detailtags, 0, sizeof (_tag_data));
memset (progs, 0, sizeof (_prog_list));

path->device1 = -1;
path->device2 = -1;
path->device3 = -1;
path->device4 = -1;
path->device5 = -1;
path->device6 = -1;
path->device7 = -1;
path->device8 = -1;

if (comm == NULL)
	{
	set_status_message (statusbar,statusbar_context, "Couldn't make comm struct.");
	return FALSE;
	}


gtk_clist_clear(GTK_CLIST(proglist));
sprintf (junk,"Controller");
progline[0] = junk;
gtk_clist_append (GTK_CLIST(proglist),progline);

gtk_clist_clear (GTK_CLIST(taglist));


set_status_message (statusbar, statusbar_context, "Connecting to PLC.");
(gchar *)comm->hostname = gtk_entry_get_text (GTK_ENTRY(plc_address));
establish_connection (comm, services, debug);
if (comm->error != 0)
	{
	set_status_message (statusbar, statusbar_context, "Couldn't connect to PLC.");
	return FALSE;
	}
set_status_message (statusbar, statusbar_context, "Connected to PLC.");
get_backplane_data(comm, backplane, rack, path, debug);
who(comm, rack, NULL, debug);
path->device1 = 1;
path->device2 = rack->cpulocation;
//get_object_config_list(comm, path, 0, configtags, debug);
get_object_details_list(comm, path, 0, detailtags, debug);


sprintf (text, "Reading %d tags from ControlLogix.",detailtags->count);
set_status_message (statusbar, statusbar_context, text);
y = detailtags->count;
for (z=0; z< y; z++)
	get_object_details(comm, path, detailtags->tag[z], debug);



set_status_message (statusbar, statusbar_context, "Reading Program Names and tags...");

get_program_list(comm, path, progs, debug);


for (x=0; x< progs->count; x++)
	{
	gchar *row[] = {NULL, NULL};
	gchar name[48];
	program_tags[x] = malloc(sizeof(_tag_data));
	get_program_details(comm, path, progs->prog[x],debug);
	for (y = 0; y < detailtags->count; y++)
		{
		if (detailtags->tag[y]->linkid == progs->prog[x]->linkid)
			{
			strcpy(progs->prog[x]->name, detailtags->tag[y]->name);
			}
		}
	sprintf (name, "%s",progs->prog[x]->name);
	row[0] = name;
	gtk_clist_append (GTK_CLIST(proglist),row);
	get_object_details_list(comm, path, progs->prog[x]->base, program_tags[x],debug);
	for (y=0; y<program_tags[x]->count; y++)
		get_object_details(comm, path, program_tags[x]->tag[y], debug);
	}

gtk_clist_select_row(GTK_CLIST(proglist),0,0);


set_status_message (statusbar, statusbar_context, "Ready..");


return TRUE;
}






int main (int argc, char **argv)
{

gtk_init(&argc, &argv);
tagnum = -1;


window =  gtk_window_new(GTK_WINDOW_TOPLEVEL);
gtk_widget_set_usize(GTK_WIDGET(window),800,600);
vbox = gtk_vbox_new(FALSE,0);
gtk_container_add(GTK_CONTAINER(window),vbox);
statusbar = gtk_statusbar_new();
statusbar_context = gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar), "default");
set_status_message (statusbar, statusbar_context, "Not Connected...");
//gtk_container_add(GTK_CONTAINER(window),statusbar);

/* PLC Address Entry box */

plc_address = gtk_entry_new ();
plc_label = gtk_label_new ("PLC Address");
plc_address_box = gtk_vbox_new(FALSE,0);
gtk_box_pack_start (GTK_BOX(plc_address_box), plc_address, FALSE, FALSE, 0);
gtk_box_pack_start (GTK_BOX(plc_address_box), plc_label, FALSE, FALSE, 0);


/* Create the connect button and add the address box */

connect_button = gtk_button_new();
connect_label = gtk_label_new ("Connect to PLC");
gtk_container_add(GTK_CONTAINER(connect_button),connect_label);
connect_box = gtk_hbox_new(TRUE,0);
gtk_box_pack_start (GTK_BOX(connect_box),connect_button, FALSE, FALSE, 1);
gtk_box_pack_start (GTK_BOX(connect_box),plc_address_box, FALSE, FALSE, 5);

/* The Program list and label... */

progbox = gtk_scrolled_window_new (NULL, NULL);
gtk_widget_set_usize (GTK_WIDGET(progbox), 150,0);
gtk_container_set_border_width(GTK_CONTAINER(progbox),5);
gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW(progbox), GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
proglist = gtk_clist_new_with_titles(1,progtitle);
gtk_clist_set_shadow_type(GTK_CLIST(proglist), GTK_SHADOW_OUT);
gtk_clist_set_column_width(GTK_CLIST(proglist),0,150);
gtk_container_add (GTK_CONTAINER(progbox), proglist);
gtk_clist_select_row (GTK_CLIST(proglist),0,0);

/* Create the top display line... */

topline = gtk_hbox_new(FALSE,0);
gtk_box_pack_start(GTK_BOX(topline),connect_box, FALSE, FALSE, 0);


/* Create the tag list window */

tag_window = gtk_scrolled_window_new (NULL, NULL);
gtk_container_set_border_width (GTK_CONTAINER(tag_window), 5);
gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW(tag_window),GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
taglist = gtk_clist_new_with_titles (8,titles);
gtk_clist_column_titles_active(GTK_CLIST(taglist));
gtk_clist_set_shadow_type (GTK_CLIST(taglist), GTK_SHADOW_OUT);
gtk_clist_set_column_width (GTK_CLIST(taglist), 0,200);
gtk_container_add (GTK_CONTAINER(tag_window), taglist);

/* Create the data window */

data_window = gtk_scrolled_window_new (NULL,NULL);
gtk_container_set_border_width (GTK_CONTAINER(data_window), 5);
gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW(data_window), 0,0);
data_widget = gtk_text_new(NULL,NULL);
gtk_text_set_editable (GTK_TEXT(data_widget), FALSE);
gtk_text_set_word_wrap (GTK_TEXT(data_widget), TRUE);
gtk_text_set_line_wrap (GTK_TEXT(data_widget), TRUE);
gtk_text_insert (GTK_TEXT(data_widget), NULL, NULL, NULL, "No Data Read...", -1);
gtk_container_add (GTK_CONTAINER(data_window), data_widget);

/* Create the right hand display  */
rightwin = gtk_vbox_new(TRUE,0);
gtk_box_pack_start (GTK_BOX(rightwin),tag_window, TRUE, TRUE, 2);
gtk_box_pack_start (GTK_BOX(rightwin),data_window, TRUE, TRUE, 2);

/* Add in the program list */
midline = gtk_hbox_new(FALSE,0);
gtk_box_pack_start (GTK_BOX(midline), progbox, FALSE, TRUE, 0);
gtk_box_pack_start (GTK_BOX(midline), rightwin, TRUE, TRUE, 0);


/* Put it all together for the GUI */

gtk_box_pack_start (GTK_BOX(vbox), topline, FALSE, FALSE, 0);

/*gtk_box_pack_start (GTK_BOX(vbox), tag_window, TRUE, TRUE, 2);
gtk_box_pack_start (GTK_BOX(vbox), data_window, TRUE, TRUE,2);*/
gtk_box_pack_start (GTK_BOX(vbox), midline, TRUE, TRUE,2);

gtk_box_pack_start (GTK_BOX(vbox), statusbar, FALSE, FALSE, 0);


gtk_window_set_title (GTK_WINDOW(window), "gCL - ControlLogix Monitor");

gtk_signal_connect (GTK_OBJECT(window), "delete_event", GTK_SIGNAL_FUNC(delete_event_cb), NULL);
gtk_signal_connect (GTK_OBJECT(window), "destroy", GTK_SIGNAL_FUNC(destroy), NULL);
gtk_signal_connect (GTK_OBJECT(connect_button), "clicked", GTK_SIGNAL_FUNC(connect_to_plc), NULL);
gtk_signal_connect (GTK_OBJECT(proglist), "select_row", GTK_SIGNAL_FUNC(display_tags), NULL);
gtk_signal_connect (GTK_OBJECT(taglist), "select_row", GTK_SIGNAL_FUNC(setup_read_tag), NULL);
//gtk_signal_connect (GTK_OBJECT(window), "realize" ,set_win_icon, NULL);
gtk_timeout_add (100,(GtkFunction) read_tag_value, NULL);

gtk_widget_show_all(window);

gtk_main();
return 0;
}





